#ifndef __line_h__
#define __line_h__

#include "marker.h"

class Line : public Marker {
private:
  Vector p2;
  int p1Arrow;
  int p2Arrow;

  void render(Drawable, const Matrix&, GC);

public:
  Line(Frame* parent, const Vector& ctr, const Vector& p, int a1, int a2,
       const char* clr, const char* f, const char* t, unsigned short prop);

  void updateBBox();
  void updateCoords(Matrix&);
  void draw();
  void drawXOR();
  void drawMagnifier(const Matrix&);
  void move(const Vector&);
  void moveTo(const Vector&);
  void edit(const Vector&, int);
  void ps(int);
  int isIn(const Vector&);

  const Vector& getP1() {return center;}
  const Vector& getP2() {return p2;}
  void setP1(const Vector&);
  void setP2(const Vector&);
  void setP1Arrow(int);
  void setP2Arrow(int);
  int getP1Arrow() {return p1Arrow;}
  int getP2Arrow() {return p2Arrow;}
  double getDistance(int);

  void list(ostream&, int, int, const char*);
  void listProperties(ostream&);
  void listFtools(ostream&, int, int, const char*);
  void listSAOtng(ostream&, int, int, const char*);
};

#endif
